//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  TRichEdit evr[R|[lgŕ\
//  (1 łɌ肷ꍇ)
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2003N1205 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, plPrev, RichEdit, ComCtrls;

type
  TForm1 = class(TForm)
    plPrev1: TplPrev;
    btnPreview: TSpeedButton;
    RichEdit1: TRichEdit;
    procedure btnPreviewClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    procedure TestPrint;
    procedure RichEditPrint(X1, X2, Y1, Y2: Integer ; Rich: TRichEdit);
  public
    { Public 錾 }
  end;

  function MiliToTwips(V: Integer): Integer;
  function TwipsToMili(V: Integer): Integer;
  
var
  Form1: TForm1;

implementation

type
  TPrev = class(TCustomplPrev);

{$R *.DFM}

//=============================================================================
//  TRichEdit (teLXg) ̓Ǎ
//  [h̕ RTF `ŕۑĂΓǍ݉\
//=============================================================================
procedure TForm1.FormShow(Sender: TObject);
var
  AFilePath : String;
begin
  AFilePath := ExtractFilePath(Application.ExeName) + 'RichText.RTF';
  if FileExists(AFilePath) then begin
    RichEdit1.Lines.LoadFromFile(AFilePath);
    Self.Width  := 750;
    Self.Height := 500;
  end;
end;

//=============================================================================
//  [vr[] {^ňvr[Jn
//  \
//=============================================================================
procedure TForm1.btnPreviewClick(Sender: TObject);
begin
  plPrev1.Title    := 'TRichEdit eXg';
  plPrev1.ProcName := TestPrint;
  plPrev1.ShowModal;
end;

//=============================================================================
//  vr[(\)̈\bh
//  \ ProcName vpeBŎw肷郁\bhɂ͈gpłȂ
//  ł͕ʂ̕`惋[`쐬ČďoĂD
//=============================================================================
procedure TForm1.TestPrint;
var
  LPaperWidth    : Integer;
  LPaperHeight   : Integer; 
begin
  // ݂̃v^̐ݒ TplSetPrinter R|̒lƂĎ擾
  plPrev1.plSetPrinter.GetPrinterInfo;
  // TplSetPrinter ̏ɂėpTCỸvpeBZbg
  TPrev(plPrev1).SetPaperInfo;  

  //  pTCY (0.1 mm P) 擾Ă
  LPaperWidth  := plPrev1.PaperWidth;
  LPaperHeight := plPrev1.PaperHeight;
  

  plPrev1.FontHeight(60);
  plPrev1.TextOut(200, 200, 'b`GfBg̈');
  RichEditPrint(300, LPaperWidth - 300, 450, LPaperHeight - 300, RichEdit1);
end;

//=============================================================================
//  TRichEdit ̓e`
//  X1       : `̈̍[ X Wl (0.1 mm P)
//  X2       : `̈̉E[ X Wl (0.1 mm P)
//  Y1       : `̈̏[ Y Wl (0.1 mm P)
//  Y2       : `̈̉[ Y Wl (0.1 mm P)
//  RichEdit : TRichEdit
//=============================================================================
procedure TForm1.RichEditPrint(X1, X2, Y1, Y2: Integer; Rich: TRichEdit);
var
  LRange   : TFormatRange;
  LSaveMap : Integer;
begin
  // Range 0 (null) Ŗ߂
  FillChar(LRange, SizeOf(TFormatRange), #0);

  // RichEdit1̐ݒ
  // o͐foCX̃nh
  LRange.hdc := plPrev1.Canvas.Handle;
  // ݒ肷foCX̃nh
  LRange.hdcTarget := LRange.hdc;

  // `̈̎w (Twips P)
  LRange.rc.Left   := MiliToTwips(X1);
  LRange.rc.Right  := MiliToTwips(X2);
  LRange.rc.Top    := MiliToTwips(Y1);
  LRange.rc.Bottom := MiliToTwips(Y2);

  //p1ł̃TCY
  // {͗pTCY Twips Ŏw肷ׂ?
  LRange.rcPage := LRange.rc;

  // eLXg̍ŏ
  LRange.chrg.cpMin := 0;
  // Ō܂ (-1 ŎvZ)
  LRange.chrg.cpMax := -1;

  // }bv[h MM_TEXT ɂđÕ}bv[h LSaveMap ɕۑ
  LSaveMap := SetMapMode(LRange.hdc, MM_TEXT);
  // obt@̃tbV}
  SendMessage(Rich.Handle, EM_FORMATRANGE, 0, 0);
  try
     
    SendMessage(Rich.Handle, EM_FORMATRANGE, 1, Longint(Addr(LRange)));
  finally
    // obt@̃tbV
    SendMessage(Rich.Handle, EM_FORMATRANGE, 0, 0);
    // }bv[hɖ߂
    // TplPrevł 0.1 mmm Pʂɖ߂Ƃ
    SetMapMode(LRange.hdc, LSaveMap);
    TPrev(plPrev1).ScaleInitialize(plPrev1.Canvas, False);
  end;

  // TRichEdit IYWl TwipsToMilli Ŏ擾Ĉ
  plPrev1.Canvas.Font.Size := 15;
  plPrev1.Canvas.TextOut(200, TwipsToMili(LRange.rc.Bottom), '̍s');
end;

//-----------------------------------------------------------------------------
//  0.1 mm Pʂ̍Wl Twips lɕϊ֐
//
//  Ql
//  1 [inch] = 72 [pt]
//  1 [inch] = 1440 [Twips]
//  1 [pt]   = 20 [Twips]
//  1 [inch] = 25.4 [mm]
//   x mm  pt (|Cg) ɊZ鎮
//     pt := x * 72 / 25.4
//
//  ̌vZ TplPrev R|p.ʓIȊZ̓v^̉𑜓x̍lKv
//-----------------------------------------------------------------------------
function MiliToTwips(V: Integer): Integer;
begin
  Result := Trunc(V * 1440.0 / 254.0);
end;

//-------------------------------------------------------------------------------
//  Twips Pʂ̒l 0.1 mm Pʂ̍Wlɕϊ֐
//  ̌vZTplPrevR|p.ʓIȊZ̓v^̉𑜓x̍lKv
//-------------------------------------------------------------------------------
function TwipsToMili(V: Integer): Integer;
begin
  Result := Trunc(V * 254.0 / 1440)
end;

end.
